Support of versioning in deb packages; addressing also comments to change 1593
[osm/RO.git] / scripts / install-openmano.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
25 #Get needed packages, source code and configure to run openmano
26 #Ask for database user and password if not provided
27
28 function usage(){
29 echo -e "usage: sudo $0 [OPTIONS]"
30 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
32 echo -e " OPTIONS"
33 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
35 echo -e " -q --quiet: install in unattended mode"
36 echo -e " -h --help: show this help"
37 echo -e " --develop: install last version for developers, and do not configure as a service"
38 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
39 echo -e " --force: makes idenpotent, delete previous installations folders if needed"
40 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
41 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
42 echo -e " --no-db: do not install mysql server"
43 }
44
45 function install_packages(){
46 [ -x /usr/bin/apt-get ] && apt-get install -y $*
47 [ -x /usr/bin/yum ] && yum install -y $*
48
49 #check properly installed
50 for PACKAGE in $*
51 do
52 PACKAGE_INSTALLED="no"
53 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
54 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
55 if [ "$PACKAGE_INSTALLED" = "no" ]
56 then
57 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
58 exit 1
59 fi
60 done
61 }
62
63 GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
64 DBUSER="root"
65 DBPASSWD=""
66 DBPASSWD_PARAM=""
67 QUIET_MODE=""
68 DEVELOP=""
69 FORCEDB=""
70 FORCE=""
71 NOCLONE=""
72 NO_PACKAGES=""
73 NO_DB=""
74 while getopts ":u:p:hiq-:" o; do
75 case "${o}" in
76 u)
77 export DBUSER="$OPTARG"
78 ;;
79 p)
80 export DBPASSWD="$OPTARG"
81 export DBPASSWD_PARAM="-p$OPTARG"
82 ;;
83 q)
84 export QUIET_MODE=yes
85 export DEBIAN_FRONTEND=noninteractive
86 ;;
87 h)
88 usage && exit 0
89 ;;
90 -)
91 [ "${OPTARG}" == "help" ] && usage && exit 0
92 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
93 [ "${OPTARG}" == "forcedb" ] && FORCEDB="y" && continue
94 [ "${OPTARG}" == "force" ] && FORCEDB="y" && FORCE="y" && continue
95 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
96 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
97 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
98 [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue
99 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
100 exit 1
101 ;;
102 \?)
103 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
104 exit 1
105 ;;
106 :)
107 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
108 exit 1
109 ;;
110 *)
111 usage >&2
112 exit 1
113 ;;
114 esac
115 done
116
117 #check root privileges and non a root user behind
118 [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
119 if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
120 then
121 [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK
122 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
123 export SUDO_USER=root
124 fi
125
126 #Discover Linux distribution
127 #try redhat type
128 [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
129 #if not assuming ubuntu type
130 [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
131 if [ "$_DISTRO" == "Ubuntu" ]
132 then
133 _RELEASE=$(lsb_release -rs)
134 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
135 then
136 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK
137 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
138 _RELEASE = 14
139 fi
140 elif [ "$_DISTRO" == "CentOS" ]
141 then
142 _RELEASE="7"
143 if ! cat /etc/redhat-release | grep -q "7."
144 then
145 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK
146 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
147 fi
148 elif [ "$_DISTRO" == "Red" ]
149 then
150 _RELEASE="7"
151 if ! cat /etc/redhat-release | grep -q "7."
152 then
153 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK
154 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
155 fi
156 else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
157 _DISTRO_DISCOVER=$_DISTRO
158 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
159 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
160 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK
161 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
162 fi
163
164 #check if installed as a service
165 INSTALL_AS_A_SERVICE=""
166 [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
167 #Next operations require knowing OPENMANO_BASEFOLDER
168 if [[ -z "$NOCLONE" ]]; then
169 if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then
170 OPENMANO_BASEFOLDER=__openmano__${RANDOM}
171 else
172 OPENMANO_BASEFOLDER="${PWD}/openmano"
173 fi
174 [[ -n "$FORCE" ]] && rm -rf $OPENMANO_BASEFOLDER #make idempotent
175 else
176 HERE=$(realpath $(dirname $0))
177 OPENMANO_BASEFOLDER=$(dirname $HERE)
178 fi
179
180
181 if [[ -z "$NO_PACKAGES" ]]
182 then
183 echo '
184 #################################################################
185 ##### UPDATE REPOSITORIES #####
186 #################################################################'
187 [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
188
189 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
190 [ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
191 [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
192 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
193 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
194
195 fi
196
197 if [[ -z "$NO_PACKAGES" ]]
198 then
199 echo '
200 #################################################################
201 ##### INSTALL REQUIRED PACKAGES #####
202 #################################################################'
203 [ "$_DISTRO" == "Ubuntu" ] && install_packages "git screen wget mysql-client"
204 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git screen wget mariadb-client"
205
206 echo '
207 #################################################################
208 ##### INSTALL PYTHON PACKAGES #####
209 #################################################################'
210 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip"
211 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip"
212 #The only way to install python-bottle on Centos7 is with easy_install or pip
213 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
214
215 #required for vmware connector TODO move that to separete opt in install script
216 sudo pip install --upgrade pip
217 sudo pip install pyvcloud
218 sudo pip install progressbar
219 sudo pip install prettytable
220 sudo pip install pyvmomi
221
222 #requiered for AWS connector
223 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto"
224 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exist with this name, or PIP should be used
225
226 #install openstack client needed for using openstack as a VIM
227 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient"
228 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient #TODO revise if gcc python-pip is needed
229 fi #[[ -z "$NO_PACKAGES" ]]
230
231 if [[ -z $NOCLONE ]]; then
232 echo '
233 #################################################################
234 ##### DOWNLOAD SOURCE #####
235 #################################################################'
236 su $SUDO_USER -c "git clone ${GIT_URL} ${OPENMANO_BASEFOLDER}"
237 su $SUDO_USER -c "cp ${OPENMANO_BASEFOLDER}/.gitignore-common ${OPENMANO_BASEFOLDER}/.gitignore"
238 [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} checkout tags/v1.0.2"
239 fi
240
241 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
242 then
243 echo '
244 #################################################################
245 ##### CONFIGURE firewalld #####
246 #################################################################'
247 KK=yes
248 [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK
249 if [ "$KK" != "n" -a "$KK" != "no" ]
250 then
251 #Creates a service file for openmano
252 echo '<?xml version="1.0" encoding="utf-8"?>
253 <service>
254 <short>openmanod</short>
255 <description>openmanod service</description>
256 <port protocol="tcp" port="9090"/>
257 </service>' > /etc/firewalld/services/openmanod.xml
258 #put proper permissions
259 pushd /etc/firewalld/services > /dev/null
260 restorecon openmanod.xml
261 chmod 640 openmanod.xml
262 popd > /dev/null
263 #Add the openmanod service to the default zone permanently and reload the firewall configuration
264 firewall-cmd --permanent --add-service=openmanod > /dev/null
265 firewall-cmd --reload > /dev/null
266 echo "done."
267 else
268 echo "skipping."
269 fi
270 fi
271
272 echo '
273 #################################################################
274 ##### CONFIGURE OPENMANO CLIENT #####
275 #################################################################'
276 #creates a link at ~/bin if not configured as a service
277 if [[ -z "$INSTALL_AS_A_SERVICE" ]]
278 then
279 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
280 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
281 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
282 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
283 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/openmano' "'${HOME}/bin/openmano'
284 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report'
285 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh' "'${HOME}/bin/service-openmano'
286
287 #insert /home/<user>/bin in the PATH
288 #skiped because normally this is done authomatically when ~/bin exist
289 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
290 #then
291 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
292 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
293 #fi
294 if [[ $SUDO_USER == root ]]
295 then
296 if ! echo $PATH | grep -q "${HOME}/bin"
297 then
298 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
299 fi
300 fi
301 fi
302
303 #configure arg-autocomplete for this user
304 #in case of minimal instalation this package is not installed by default
305 [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
306 #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
307 su $SUDO_USER -c 'activate-global-python-argcomplete --user'
308 if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
309 then
310 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
311 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
312 fi
313
314 if [ -z "$NO_DB" ]; then
315 echo '
316 #################################################################
317 ##### INSTALL DATABASE SERVER #####
318 #################################################################'
319
320 if [ -n "$QUIET_MODE" ]; then
321 DB_QUIET='-q'
322 fi
323 if [ -n "$FORCEDB" ]; then
324 DB_FORCE='--forcedb'
325 fi
326 ${OPENMANO_BASEFOLDER}/scripts/install-db-server.sh -u $DBUSER $DBPASSWD_PARAM $DB_QUIET $DB_FORCE || exit 1
327 fi
328
329 if [[ -n "$INSTALL_AS_A_SERVICE" ]]
330 then
331 echo '
332 #################################################################
333 ##### CONFIGURE OPENMANO SERVICE #####
334 #################################################################'
335
336 ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"`
337 # rm -rf ${OPENMANO_BASEFOLDER}
338 # alias service-openmano="service openmano"
339 # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
340
341 echo
342 echo "Done! installed at /opt/openmano"
343 echo " Manage server with 'sudo service openmano start|stop|status|...' "
344
345
346 else
347
348 echo
349 echo "Done! you may need to logout and login again for loading client configuration"
350 echo " Run './${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh start' for starting openmano in a screen"
351
352 fi
353